<template>
  <div class="login">
    <div class="logo-box">
      <img class="logo" src="@/assets/images/login/logo.png" alt="logo" />
      <div class="tile">
        <img class="icon" src="@/assets/images/login/icon.png" alt="icon" />
        <div class="title">{{ title }}</div>
      </div>
    </div>
    <div class="form-box">
      <el-form ref="loginRef" :model="loginForm" :rules="loginRules" class="login-form">
        <div class="top">
          <div>欢迎登录</div>
          <div class="line"></div>
        </div>
        <el-form-item prop="username" style="margin-bottom: 38px;">
          <el-input v-model="loginForm.username" type="text" size="large" auto-complete="off" placeholder="账号">
            <template #prefix><svg-icon icon-class="user" class="el-input__icon input-icon" /></template>
          </el-input>
        </el-form-item>
        <el-form-item prop="password">
          <el-input v-model="loginForm.password" type="password" size="large" auto-complete="off" placeholder="密码"
            @keyup.enter="handleLogin">
            <template #prefix><svg-icon icon-class="password" class="el-input__icon input-icon" /></template>
          </el-input>
        </el-form-item>
        <!-- <el-form-item prop="code" v-if="captchaEnabled">
          <el-input
            v-model="loginForm.code"
            size="large"
            auto-complete="off"
            placeholder="验证码"
            style="width: 63%"
            @keyup.enter="handleLogin"
          >
            <template #prefix><svg-icon icon-class="validCode" class="el-input__icon input-icon" /></template>
          </el-input>
          <div class="login-code">
            <img :src="codeUrl" @click="getCode" class="login-code-img"/>
          </div>
        </el-form-item> -->
        <!-- <el-checkbox v-model="loginForm.rememberMe" style="margin:0px 0px 25px 0px;">记住密码</el-checkbox> -->
        <el-form-item style="width:100%;margin-top:78px;">
          <el-button :loading="loading" size="large" type="primary" class="login-btn" @click.prevent="handleLogin">
            <span v-if="!loading">登 录</span>
            <span v-else>登 录 中...</span>
          </el-button>
          <div style="float: right;" v-if="register">
            <router-link class="link-type" :to="'/register'">立即注册</router-link>
          </div>
        </el-form-item>
      </el-form>
    </div>
    <!--  底部  -->
    <!-- <div class="el-login-footer">
      <span>Copyright © 2018-2025 All Rights Reserved.</span>
    </div> -->
  </div>
</template>

<script setup>
import { getCodeImg } from "@/api/login"
import Cookies from "js-cookie"
import { sm4 as SM4 } from 'gm-crypt'
import { encrypt, decrypt } from "@/utils/jsencrypt"
import useUserStore from '@/store/modules/user'
import useAppStore from '@/store/modules/app'
import usePermissionStore from '@/store/modules/permission'
import { useRoute, useRouter } from 'vue-router'
const route = useRoute()
const router = useRouter()
const permissionStore = usePermissionStore()



const title = import.meta.env.VITE_APP_TITLE
const userStore = useUserStore()
const appStore = useAppStore()

const { proxy } = getCurrentInstance()

const loginForm = ref({
  username: "",
  password: "",
  rememberMe: false,
  code: "",
  uuid: ""
})

const loginRules = {
  username: [{ required: true, trigger: "blur", message: "请输入您的账号" }],
  password: [{ required: true, trigger: "blur", message: "请输入您的密码" }],
  code: [{ required: true, trigger: "change", message: "请输入验证码" }]
}

const codeUrl = ref("")
const loading = ref(false)
// 验证码开关
const captchaEnabled = ref(true)
// 注册开关
const register = ref(false)
const redirect = ref(undefined)

watch(route, (newRoute) => {
  redirect.value = newRoute.query && newRoute.query.redirect
}, { immediate: true })

function handleLogin() {
  proxy.$refs.loginRef.validate(valid => {
    if (valid) {
      loading.value = true

      userStore.login(loginForm.value).then( (res) => {
        console.log('res123', res)
        let data = res
        const { menus } = data
        // return
        // 用户数据整理
        let user = data.tsysUser
        let loginBlankMenus = false
        if (menus.length === 0) {
          loginBlankMenus = true
        }

        //  appStore.signOut('login')
          appStore.setNav(menus)
          appStore.setallNav(menus)
          appStore.setNavStatus({ type: 'manage' })
          appStore.setUserInfo({ user, licenseRst: data.licenseRst, loginBlankMenus })

          // 存储token和登录信息
          window.sessionStorage.setItem('__token', data.token)
          const loginStr = JSON.stringify({
            username: loginForm.value.username,
            password: encryptPassword(loginForm.value.password)
          })
          window.sessionStorage.setItem('login', loginStr)
          router.push({ path: '/'})
      }).catch(() => {
        loading.value = false
        // 重新获取验证码
        if (captchaEnabled.value) {
          // getCode()
        }
      })
    }
  })
}
// // 使用示例
// const transformedRoutes = transformRoutes(originalRoutes);
// console.log(transformedRoutes);
function encryptPassword(plainPassword) {
  const sm4Config = {
    key: "GJstSK_YBD=gSOFT",
    mode: 'ecb',
    cipherType: 'base64'
  }
  const sm4 = new SM4(sm4Config)

  try {
    return sm4.encrypt(plainPassword)
  } catch (error) {
    console.error('加密失败:', error)
    throw new Error('密码加密处理失败')
  }
}

function getCode() {
  getCodeImg().then(res => {
    captchaEnabled.value = res.captchaEnabled === undefined ? true : res.captchaEnabled
    if (captchaEnabled.value) {
      codeUrl.value = "data:image/gif;base64," + res.img
      loginForm.value.uuid = res.uuid
    }
  })
}

function getCookie() {
  const username = Cookies.get("username")
  const password = Cookies.get("password")
  const rememberMe = Cookies.get("rememberMe")
  loginForm.value = {
    username: username === undefined ? loginForm.value.username : username,
    password: password === undefined ? loginForm.value.password : decrypt(password),
    rememberMe: rememberMe === undefined ? false : Boolean(rememberMe)
  }
}

// getCode()
// getCookie()
</script>

<style lang='scss' scoped>
.login {
  display: flex;
  justify-content: flex-end;
  align-items: center;
  height: 100%;
  background-image: url("../assets/images/login/background.jpg");
  background-size: cover;
  padding-right: 14%;
  .logo-box{
    position: absolute;
    top: 63px;
    left: 49px;
    display: flex;
    align-items: center;
    .logo{
      margin-right: 40px;
      width: 300px;
      height: 47.04px;
    }
    .tile{
      font-size: 36px;
      font-weight: 400;
      letter-spacing: 0px;
      line-height: 46.8px;
      color: rgba(51, 51, 51, 1);
      display: flex;
      align-items: center;
      font-family: 'YSBTH';
      .icon{
        width: 40px;
        height: 40px;
        margin-right: 13px;
      }
    }
  }
}
.form-box{
  padding: 4px;
  background: linear-gradient(90deg, rgba(176, 213, 255, 1) 0%, rgba(235, 235, 235, 1) 5.71%, rgba(255, 255, 255, 1) 100%);
  border-radius: 15px;
}
.login-form {
  padding: 48px 70px 98px 70px;
  box-sizing: border-box;
  background: rgba(235, 245, 255, 0.65);
  backdrop-filter: blur(10px);
  border-radius: 15px;
  overflow: hidden;
  z-index: 1;
  .top{
    font-size: 24px;
    font-weight: 500;
    letter-spacing: 0px;
    line-height: 34.75px;
    color: rgba(51, 51, 51, 1);
    display: flex;
    flex-direction: column;
    align-items: center;
    .line{
      margin-top: 14px;
      margin-bottom: 50px;
      width: 50px;
      height: 4px;
      border-radius: 5px;
      background: rgba(11, 136, 251, 1);
    }
  }
  .el-input {
    width: 300px;
    height: 40px;
    input {
      height: 40px;
    }
  }
  .input-icon {
    height: 39px;
    width: 14px;
    margin-left: 0px;
  }
  .login-btn{
    width:100%;
    height: 48px;
    border-radius: 40px;
    background: rgba(11, 136, 251, 1);
    box-shadow: 0px 2px 19px  rgba(52, 120, 237, 0.36);
  }
}
.login-tip {
  font-size: 13px;
  text-align: center;
  color: #bfbfbf;
}
.login-code {
  width: 33%;
  height: 40px;
  float: right;
  img {
    cursor: pointer;
    vertical-align: middle;
  }
}
.el-login-footer {
  height: 40px;
  line-height: 40px;
  position: fixed;
  bottom: 0;
  width: 100%;
  text-align: center;
  color: #fff;
  font-family: Arial;
  font-size: 12px;
  letter-spacing: 1px;
}
.login-code-img {
  height: 40px;
  padding-left: 12px;
}
</style>
